Index: src/backend/access/transam/xlog.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/access/transam/xlog.c,v
retrieving revision 1.335
diff -c -r1.335 xlog.c
*** src/backend/access/transam/xlog.c	7 Apr 2009 00:31:26 -0000	1.335
--- src/backend/access/transam/xlog.c	22 Apr 2009 08:47:45 -0000
***************
*** 4850,4859 ****
--- 4850,4871 ----
  		 * If we are establishing a new timeline, we have to copy data from
  		 * the last WAL segment of the old timeline to create a starting WAL
  		 * segment for the new timeline.
+ 		 *
+ 		 * Notify the archiver that the last WAL segment of the old timeline
+ 		 * is ready to copy to archival storage. Otherwise, it is not archived
+ 		 * for a while.
  		 */
  		if (endTLI != ThisTimeLineID)
+ 		{
  			XLogFileCopy(endLogId, endLogSeg,
  						 endTLI, endLogId, endLogSeg);
+ 
+ 			if (XLogArchivingActive())
+ 			{
+ 				XLogFileName(xlogpath, endTLI, endLogId, endLogSeg);
+ 				XLogArchiveNotify(xlogpath);
+ 			}
+ 		}
  	}
  
  	/*
